
Imports System.Data.SqlClient
Imports Microsoft.SqlServer.Server

Public Class FirstSQLCLRVB
    Public Shared Function ListEmployees() As Integer
        Dim conn As SqlConnection
        Dim cmd As SqlCommand
        Dim rdr As SqlDataReader

        SqlContext.Pipe.Send("Current Contacts as of: " & _
                                 System.DateTime.Now.ToString() & _
                                 "\n")

        conn = New SqlConnection("context connection=true")

        conn.Open()

        cmd = New SqlCommand("SELECT Person.Contact.LastName, " & _
            "Person.Contact.FirstName, Person.Contact.EmailAddress, " & _
            "HumanResources.Employee.HireDate FROM Person.Contact " & _
            "Inner Join HumanResources.Employee On " & _
            "Person.Contact.ContactID = HumanResources.Employee.ContactID " & _
            "ORDER BY LastName, FirstName", conn)
        rdr = cmd.ExecuteReader()
        SqlContext.Pipe.Send(rdr)

        conn.Close()

        Return 0
    End Function

    Public Shared Function ListEmployeesWithVariable(ByVal orderBy As String) As Integer

        Dim conn As SqlConnection
        Dim cmd As SqlCommand
        Dim rdr As SqlDataReader

        SqlContext.Pipe.Send("Current Contacts as of: " & _
            System.DateTime.Now.ToString() + "\n")

        conn = New SqlConnection("context connection=true")

        conn.Open()

        cmd = New SqlCommand("SELECT Person.Contact.LastName, Person.Contact.FirstName, Person.Contact.EmailAddress, HumanResources.Employee.HireDate FROM Person.Contact Inner Join HumanResources.Employee On Person.Contact.ContactID = HumanResources.Employee.ContactID ORDER BY " + orderBy.ToString(), conn)
        rdr = cmd.ExecuteReader()
        SqlContext.Pipe.Send(rdr)

        conn.Close()

        Return 0
    End Function

    Public Shared Function ControllingProgramFlow(ByVal chooseFieldsToUse As Integer, ByVal chooseOrderBy As Integer) As Integer

        Dim conn As SqlConnection
        Dim cmd As SqlCommand
        Dim rdr As SqlDataReader

        SqlContext.Pipe.Send("Current Contacts as of: " & _
            System.DateTime.Now.ToString() + "\n")

        conn = New SqlConnection("context connection=true")

        conn.Open()

        Dim sql As String = "Select "

        ''First way to control flow of program, switch...case code block.
        Select Case chooseFieldsToUse

            Case 1
                sql += "Person.Contact.LastName, Person.Contact.FirstName, Person.Contact.EmailAddress, HumanResources.Employee.HireDate"

            Case 2
                sql += "Person.Contact.LastName, Person.Contact.FirstName, HumanResources.Employee.Title, HumanResources.Employee.BirthDate"

            Case 3
                sql += "Person.Contact.LastName, Person.Contact.FirstName, HumanResources.Employee.MaritalStatus, HumanResources.Employee.Gender"
        End Select

        sql += " FROM Person.Contact Inner Join HumanResources.Employee On Person.Contact.ContactID = HumanResources.Employee.ContactID ORDER BY "

        'Another way, using the if...else code block.
        If (chooseOrderBy = 1) Then
            sql += "LastName, FirstName"
        Else
            sql += "HireDate"
        End If

        cmd = New SqlCommand(sql, conn)
        rdr = cmd.ExecuteReader()
        SqlContext.Pipe.Send(rdr)

        conn.Close()
        Return 0
    End Function

    Public Shared Function ListEmployeesUsingInputParameter(ByVal searchLastName As String) As Integer

        Dim conn As SqlConnection
        Dim cmd As SqlCommand
        Dim rdr As SqlDataReader

        SqlContext.Pipe.Send("Current Contacts as of: " & _
                             System.DateTime.Now.ToString() & _
                             "\n")
        conn = New SqlConnection("context connection=true")

        conn.Open()
        cmd = New SqlCommand("SELECT Person.Contact.LastName, " & _
            "Person.Contact.FirstName, Person.Contact.EmailAddress, " & _
            "HumanResources.Employee.HireDate " & _
            "FROM Person.Contact Inner Join HumanResources.Employee " & _
            "On Person.Contact.ContactID = HumanResources.Employee.ContactID " & _
            "Where Person.Contact.LastName Like @LastName", conn)
        cmd.Parameters.Add("@LastName", SqlDbType.NVarChar)
        cmd.Parameters(0).Value = searchLastName

        rdr = cmd.ExecuteReader()
        SqlContext.Pipe.Send(rdr)
        conn.Close()
        Return 0
    End Function

    Public Shared Function ListEmployeesUsingOutputParameter(ByVal productNumber As String, ByVal color As String) As Integer

        Dim conn As SqlConnection
        Dim cmd As SqlCommand
        Dim rdr As SqlDataReader

        conn = New SqlConnection("context connection=true")

        conn.Open()

        Dim sql As String = "IF @ProductNumber IS Null"
        sql += "    BEGIN"
        sql += "        SELECT Name FROM Production.Product WHERE Color = @Color"
        sql += "        SELECT @MyMessage = 'No Product Number'"
        sql += "    END "
        sql += "ELSE"
        sql += "    BEGIN"
        sql += "        SELECT Name FROM Production.Product WHERE ProductNumber = @ProductNumber"
        sql += "        SELECT @MyMessage = 'Product Number Supplied'"
        sql += "    END "
        sql += "SELECT @MyMessage"


        cmd = New SqlCommand(sql, conn)

        cmd.Parameters.Add("@ProductNumber", SqlDbType.VarChar, 20)
        cmd.Parameters(0).Value = productNumber
        cmd.Parameters.Add("@Color", SqlDbType.VarChar, 20)
        cmd.Parameters(1).Value = color
        cmd.Parameters.Add("@MyMessage", SqlDbType.VarChar, 50)
        cmd.Parameters(2).Direction = System.Data.ParameterDirection.Output

        rdr = cmd.ExecuteReader()
        SqlContext.Pipe.Send(rdr)

        conn.Close()
        Return 0
    End Function

    Public Shared Function InsertingData(ByVal departmentName As String, ByVal groupName As String) As Integer

        Dim conn As SqlConnection
        Dim cmd As SqlCommand

        'Production (running from SQL Server)
        'conn = New SqlConnection("context connection=true")

        'Test (running from .NET)
        conn = New SqlConnection("Data Source=.\SQLEXPRESS;AttachDbFilename='C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;Integrated Security=True;Connect Timeout=30;User Instance=True")

        conn.Open()

        Dim sql As String = "INSERT INTO HumanResources.Department(Name, GroupName) VALUES ('" + departmentName.ToString() + "', '" + groupName.ToString() + "')"

        cmd = New SqlCommand(sql, conn)
        cmd.ExecuteNonQuery()

        conn.Close()

        Return 0
    End Function


    Public Shared Function UpdatingData(ByVal departmentName As String, ByVal groupName As String) As Integer
        Dim conn As SqlConnection
        Dim cmd As SqlCommand

        conn = New SqlConnection("context connection=true")

        conn.Open()

        Dim sql As String = "UPDATE HumanResources.Department SET GroupName = '" + groupName.ToString() + "' WHERE Name = '" + departmentName.ToString() + "'"

        cmd = New SqlCommand(sql, conn)
        cmd.ExecuteNonQuery()

        conn.Close()

        Return 0
    End Function

    Public Shared Function DeletingData(ByVal departmentName As String) As Integer


        Dim conn As SqlConnection
        Dim cmd As SqlCommand

        conn = New SqlConnection("context connection=true")

        conn.Open()

        Dim sql As String = "DELETE FROM HumanResources.Department WHERE Name = '" + departmentName.ToString() + "'"

        cmd = New SqlCommand(sql, conn)
        cmd.ExecuteNonQuery()
        conn.Close()
        Return 0
    End Function

    Public Shared Function UsingTemporaryTables() As Integer

        Dim conn As SqlConnection = New _
            SqlConnection("context connection=true")

        conn.Open()

        Dim sql As String = "CREATE TABLE #TempContacts"
        sql += "        (ContactID int NOT NULL PRIMARY KEY, "
        sql += "        LastName varchar(50), "
        sql += "        FirstName varchar(50))"
        sql += "  INSERT INTO #TempContacts "
        sql += "  (ContactID, LastName, FirstName) "
        sql += "  SELECT Person.Contact.ContactID, "
        sql += "  Person.Contact.LastName, "
        sql += "  Person.Contact.FirstName From Person.Contact"
        sql += "  SELECT LastName, FirstName FROM #TempContacts " & _
            "ORDER BY LastName, FirstName"


        Dim cmd As SqlCommand = New SqlCommand(sql, conn)

        Dim rdr As SqlDataReader = cmd.ExecuteReader()
        SqlContext.Pipe.Send(rdr)

        conn.Close()
        Return 0
    End Function


    Public Shared Function HandlingRuntimeErrors(ByVal departmentName As String, _
        ByVal groupName As String) As Integer

        If groupName = "" Then
            'Error handled in C#
            SqlContext.Pipe.Send("Group Name must be filled in.")
        Else

            Dim conn As SqlConnection = New SqlConnection("context connection=true")

            conn.Open()
            'Error handled in T-SQL
            Dim sql As String = "IF @DepartmentName Is Null "
            sql += "    BEGIN "
            sql += "        SELECT Message = 'No Department Name', DepartmentID = 0"
            sql += "    END "
            sql += "ELSE "
            sql += "    BEGIN "
            sql += "        INSERT INTO HumanResources.Department(Name, GroupName) "
            sql += "        VALUES (@DepartmentName, @GroupName) "
            sql += "        SELECT Message = 'Success', DepartmentID = @@Identity "
            sql += "    END "

            Dim cmd = New SqlCommand(sql, conn)
            cmd.Parameters.Add(New SqlParameter _
                ("@DepartmentName", System.Data.SqlDbType.VarChar, 50))
            cmd.Parameters(0).Value = departmentName
            cmd.Parameters.Add(New SqlParameter _
                ("@GroupName", System.Data.SqlDbType.VarChar, 50))
            cmd.Parameters(1).Value = groupName

            Dim rdr As SqlDataReader = cmd.ExecuteReader()
            SqlContext.Pipe.Send(rdr)

        End If

        Return 0

    End Function



    Public Shared Function RaisingErrors(ByVal departmentName As String, _
        ByVal groupName As String) As Integer

        Try

            Dim conn As SqlConnection = New SqlConnection("context connection=true")

            conn.Open()
            Dim sql As String = "SET NOCOUNT ON INSERT INTO "
            sql += "HumanResources.Department(Name, GroupName) VALUES "
            sql += "(@DepartmentName, @GroupName) "
            sql += "SELECT DepartmentID = @@Identity"

            Dim cmd As SqlCommand = New SqlCommand(sql, conn)
            cmd.Parameters.Add(New SqlParameter("@DepartmentName", _
                System.Data.SqlDbType.VarChar, 50))
            cmd.Parameters(0).Value = departmentName
            cmd.Parameters.Add(New SqlParameter("@GroupName", _
                System.Data.SqlDbType.VarChar, 50))
            cmd.Parameters(1).Value = groupName

            SqlContext.Pipe.ExecuteAndSend(cmd)



        Catch ex As Exception

            'This error will get sent, rather than the other, 
            'to suppress this, comment out the next line.
            SqlContext.Pipe.Send("An exception occurred during the " & _
            "execution of RaisingErrors " + ex.ToString())


        End Try

        Return 0

    End Function



    Public Shared Function UsingTransaction(ByVal departmentName As String, _
        ByVal groupName As String) As Integer

        Try
            Dim conn As SqlConnection = _
                New SqlConnection("context connection=true")

            conn.Open()
            Dim sql As String = "SET NOCOUNT ON "
            sql += "DECLARE @DepartmentID int, @LocalError int, @LocalRows int "
            sql += "BEGIN TRANSACTION "
            sql += "INSERT INTO HumanResources.Department(Name, GroupName) "
            sql += "VALUES (@DepartmentName, @GroupName) "
            sql += "SELECT @LocalError = @@Error, @LocalRows = @@RowCount "
            sql += "IF NOT @LocalError = 0 or @LocalRows = 0 "
            sql += "    BEGIN "
            sql += "        ROLLBACK TRANSACTION "
            sql += "        SELECT DepartmentID = Null, Error = @LocalError, "
            sql += "NumRows = @LocalRows "
            sql += "    END "
            sql += "ELSE "
            sql += "    BEGIN "
            sql += "        COMMIT TRAN "
            sql += "    	SELECT @DepartmentID = @@Identity "
            sql += "        SELECT DepartmentID = @DepartmentID, Error = 0, "
            sql += "        NumRows = @LocalRows "
            sql += "    END "

            Dim cmd As SqlCommand = New SqlCommand(sql, conn)
            cmd.Parameters.Add(New SqlParameter _
                ("@DepartmentName", System.Data.SqlDbType.VarChar, 50))
            cmd.Parameters(0).Value = departmentName
            cmd.Parameters.Add(New SqlParameter("@GroupName", _
                System.Data.SqlDbType.VarChar, 50))
            cmd.Parameters(1).Value = groupName

            SqlContext.Pipe.ExecuteAndSend(cmd)


        Catch ex As Exception

            'This error will get sent, rather than the other, 
            'to suppress this, comment out the next line.
            SqlContext.Pipe.Send("Transaction Rolled Back")

        End Try

        Return 0

    End Function





End Class
